Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -3162,279 +3336,320 @@
 !
 !--    Cunningham slip-flow correction (Eq. 15.30)
-       Cc = 1.0_wp + Kn * ( c_A + c_B * EXP( -c_C / Kn ) )
+       Cc = 1.0_wp + Kn * ( 1.249_wp + 0.42_wp * EXP( -0.87_wp / Kn ) )
 
 !--    Particle diffusivity coefficient (Eq. 15.29)
        mdiff = ( abo * tk * Cc ) / ( 3.0_wp * pi * avis * zdwet )
-!       
+!
 !--    Particle Schmidt number (Eq. 15.36)
-       Sc(b) = kvis / mdiff       
-!       
-!--    Critical fall speed i.e. settling velocity  (Eq. 20.4)                 
-       vc(b) = MIN( 1.0_wp, terminal_vel( 0.5_wp * zdwet, pdn, adn, avis, Cc) )
-       
-       IF ( lsdepo_vege  .AND.  plant_canopy  .AND.  lad > 0.0_wp )  THEN
-!       
-!--       Friction velocity calculated following Prandtl (1925):
+       schmidt_num(ib) = kvis / mdiff
+!
+!--    Critical fall speed i.e. settling velocity  (Eq. 20.4)
+       vc(ib) = MIN( 1.0_wp, terminal_vel( 0.5_wp * zdwet, pdn, adn, avis, Cc) )
+!
+!--    Friction velocity for deposition on vegetation. Calculated following Prandtl (1925):
+       IF ( lsdepo_pcm  .AND.  plant_canopy  .AND.  lad > 0.0_wp )  THEN
           ustar = SQRT( cdc ) * mag_u
-          CALL depo_vege( paero, b, vc(b), mag_u, ustar, kvis, Sc(b), lad )
-       ENDIF 
+          CALL depo_pcm( paero, ib, vc(ib), mag_u, ustar, kvis, schmidt_num(ib), lad )
+       ENDIF
     ENDDO
- 
- END SUBROUTINE deposition 
- 
+
+ END SUBROUTINE deposition
+
 !------------------------------------------------------------------------------!
 ! Description:
-! ------------ 
-!> Calculate change in number and volume concentrations due to deposition on 
+! ------------
+!> Calculate change in number and volume concentrations due to deposition on
 !> plant canopy.
 !------------------------------------------------------------------------------!
- SUBROUTINE depo_vege( paero, b, vc, mag_u, ustar, kvis_a, Sc, lad )
-  
-    IMPLICIT NONE 
-    
-    INTEGER(iwp), INTENT(in) ::  b  !< loop index
-    REAL(wp), INTENT(in) ::  kvis_a !< kinematic viscosity of air (m2/s)
-    REAL(wp), INTENT(in) ::  lad    !< leaf area density (m2/m3)
-    REAL(wp), INTENT(in) ::  mag_u  !< wind velocity (m/s)   
-    REAL(wp), INTENT(in) ::  Sc     !< particle Schmidt number 
-    REAL(wp), INTENT(in) ::  ustar  !< friction velocity (m/s)                                    
-    REAL(wp), INTENT(in) ::  vc     !< terminal velocity (m/s)  
-    TYPE(t_section), INTENT(inout) ::  paero(fn2b)  
-    
-    INTEGER(iwp) ::  c      !< loop index
-
-    REAL(wp) ::  alpha       !< parameter, Table 3 in Zhang et al. (2001)  
-    REAL(wp) ::  depo        !< deposition efficiency
-    REAL(wp) ::  C_Br        !< coefficient for Brownian diffusion
-    REAL(wp) ::  C_IM        !< coefficient for inertial impaction
-    REAL(wp) ::  C_IN        !< coefficient for interception
-    REAL(wp) ::  C_IT        !< coefficient for turbulent impaction   
-    REAL(wp) ::  gamma       !< parameter, Table 3 in Zhang et al. (2001)    
-    REAL(wp) ::  par_A       !< parameter A for the characteristic radius of 
-                             !< collectors, Table 3 in Zhang et al. (2001)    
-    REAL(wp) ::  rt          !< the overall quasi-laminar resistance for 
-                             !< particles
-    REAL(wp) ::  St          !< Stokes number for smooth surfaces or bluff 
-                             !< surface elements                                 
-    REAL(wp) ::  tau_plus    !< dimensionless particle relaxation time   
-    REAL(wp) ::  v_bd        !< deposition velocity due to Brownian diffusion
-    REAL(wp) ::  v_im        !< deposition velocity due to impaction
-    REAL(wp) ::  v_in        !< deposition velocity due to interception
-    REAL(wp) ::  v_it        !< deposition velocity due to turbulent impaction                                
-!
-!-- Initialise 
-    depo     = 0.0_wp 
-    rt       = 0.0_wp
-    St       = 0.0_wp
+ SUBROUTINE depo_pcm( paero, ib, vc, mag_u, ustar, kvis_a, schmidt_num, lad )
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  ic      !< loop index
+
+    INTEGER(iwp), INTENT(in) ::  ib  !< loop index
+
+    REAL(wp) ::  alpha             !< parameter, Table 3 in Z01
+    REAL(wp) ::  beta_im           !< parameter for turbulent impaction
+    REAL(wp) ::  depo              !< deposition efficiency
+    REAL(wp) ::  c_brownian_diff   !< coefficient for Brownian diffusion
+    REAL(wp) ::  c_impaction       !< coefficient for inertial impaction
+    REAL(wp) ::  c_interception    !< coefficient for interception
+    REAL(wp) ::  c_turb_impaction  !< coefficient for turbulent impaction
+    REAL(wp) ::  gamma             !< parameter, Table 3 in Z01
+    REAL(wp) ::  par_a             !< parameter A for the characteristic radius of collectors, 
+                                   !< Table 3 in Z01
+    REAL(wp) ::  par_l             !< obstacle characteristic dimension in P10
+    REAL(wp) ::  rs                !< overall quasi-laminar resistance for particles
+    REAL(wp) ::  stokes_num        !< Stokes number for smooth or bluff surfaces
+    REAL(wp) ::  tau_plus          !< dimensionless particle relaxation time
+    REAL(wp) ::  v_bd              !< deposition velocity due to Brownian diffusion
+    REAL(wp) ::  v_im              !< deposition velocity due to impaction
+    REAL(wp) ::  v_in              !< deposition velocity due to interception
+    REAL(wp) ::  v_it              !< deposition velocity due to turbulent impaction
+
+    REAL(wp), INTENT(in) ::  kvis_a       !< kinematic viscosity of air (m2/s)
+    REAL(wp), INTENT(in) ::  lad          !< leaf area density (m2/m3)
+    REAL(wp), INTENT(in) ::  mag_u        !< wind velocity (m/s)
+    REAL(wp), INTENT(in) ::  schmidt_num  !< particle Schmidt number 
+    REAL(wp), INTENT(in) ::  ustar        !< friction velocity (m/s)
+    REAL(wp), INTENT(in) ::  vc           !< terminal velocity (m/s)
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  paero  !< aerosol properties
+!
+!-- Initialise
+    rs       = 0.0_wp
     tau_plus = 0.0_wp
-    v_bd     = 0.0_wp     
-    v_im     = 0.0_wp        
-    v_in     = 0.0_wp        
-    v_it     = 0.0_wp         
-       
-    IF ( depo_vege_type == 'zhang2001' )  THEN
-!       
-!--    Parameters for the land use category 'deciduous broadleaf trees'(Table 3)     
-       par_A = 5.0E-3_wp
-       alpha = 0.8_wp
-       gamma = 0.56_wp  
-!       
-!--    Stokes number for vegetated surfaces (Seinfeld & Pandis (2006): Eq.19.24)  
-       St = vc * ustar / ( g * par_A )         
-!          
-!--    The overall quasi-laminar resistance for particles (Zhang et al., Eq. 5)        
-       rt = MAX( EPSILON( 1.0_wp ), ( 3.0_wp * ustar * EXP( -St**0.5_wp ) *    &
-                         ( Sc**( -gamma ) + ( St / ( alpha + St ) )**2.0_wp +  &
-                           0.5_wp * ( paero(b)%dwet / par_A )**2.0_wp ) ) )
-       depo = ( rt + vc ) * lad
-       paero(b)%numc = paero(b)%numc - depo * paero(b)%numc * dt_salsa
-       DO  c = 1, maxspec+1
-          paero(b)%volc(c) = paero(b)%volc(c) - depo * paero(b)%volc(c) *      &
-                             dt_salsa
-       ENDDO
-       
-    ELSEIF ( depo_vege_type == 'petroff2010' )  THEN
-!
-!--    vd = v_BD + v_IN + v_IM + v_IT + vc 
+    v_bd     = 0.0_wp
+    v_im     = 0.0_wp
+    v_in     = 0.0_wp
+    v_it     = 0.0_wp
+
+    IF ( depo_pcm_par == 'zhang2001' )  THEN
+!
+!--    Parameters for the land use category 'deciduous broadleaf trees'(Table 3)
+       alpha   = alpha_z01(depo_pcm_type_num)
+       gamma   = gamma_z01(depo_pcm_type_num)
+       par_a   = A_z01(depo_pcm_type_num, season) * 1.0E-3_wp
+!
+!--    Stokes number for vegetated surfaces (Seinfeld & Pandis (2006): Eq.19.24)
+       stokes_num = vc * ustar / ( g * par_a )
+!
+!--    The overall quasi-laminar resistance for particles (Zhang et al., Eq. 5)
+       rs = MAX( EPSILON( 1.0_wp ), ( 3.0_wp * ustar * EXP( -stokes_num**0.5_wp ) *                &
+                 ( schmidt_num**( -gamma ) + ( stokes_num / ( alpha + stokes_num ) )**2 +          &
+                 0.5_wp * ( paero(ib)%dwet / par_a )**2 ) ) )
+
+       depo = ( rs + vc ) * lad
+
+    ELSEIF ( depo_pcm_par == 'petroff2010' )  THEN
+!
+!--    vd = v_BD + v_IN + v_IM + v_IT + vc
 !--    Deposition efficiencies from Table 1. Constants from Table 2.
-       C_Br  = 1.262_wp
-       C_IM  = 0.130_wp
-       C_IN  = 0.216_wp
-       C_IT  = 0.056_wp
-       par_A = 0.03_wp   ! Here: leaf width (m)      
-!       
-!--    Stokes number for vegetated surfaces (Seinfeld & Pandis (2006): Eq.19.24)  
-       St = vc * ustar / ( g * par_A )         
+       par_l   = l_p10(depo_pcm_type_num) * 0.01_wp
+       c_brownian_diff     = c_b_p10(depo_pcm_type_num)
+       c_interception    = c_in_p10(depo_pcm_type_num)
+       c_impaction    = c_im_p10(depo_pcm_type_num)
+       beta_im = beta_im_p10(depo_pcm_type_num)
+       c_turb_impaction    = c_it_p10(depo_pcm_type_num)
+!
+!--    Stokes number for vegetated surfaces (Seinfeld & Pandis (2006): Eq.19.24)
+       stokes_num = vc * ustar / ( g * par_l )
 !
 !--    Non-dimensional relexation time of the particle on top of canopy
-       tau_plus = vc * ustar**2.0_wp / ( kvis_a * g ) 
+       tau_plus = vc * ustar**2 / ( kvis_a * g )
 !
 !--    Brownian diffusion
-       v_bd = mag_u * C_Br * Sc**( -2.0_wp / 3.0_wp ) *                        &
-              ( mag_u * par_A / kvis_a )**( -0.5_wp )
+       v_bd = mag_u * c_brownian_diff * schmidt_num**( -0.66666666_wp ) *                          &
+              ( mag_u * par_l / kvis_a )**( -0.5_wp )
 !
 !--    Interception
-       v_in = mag_u * C_IN * paero(b)%dwet / par_A * ( 2.0_wp + LOG( 2.0_wp *  &
-              par_A / paero(b)%dwet ) )                     
+       v_in = mag_u * c_interception * paero(ib)%dwet / par_l * ( 2.0_wp + LOG( 2.0_wp * par_l /    &
+              paero(ib)%dwet ) )
 !
 !--    Impaction: Petroff (2009) Eq. 18
-       v_im = mag_u * C_IM * ( St / ( St + 0.47_wp ) )**2.0_wp
-       
+       v_im = mag_u * c_impaction * ( stokes_num / ( stokes_num + beta_im ) )**2
+!
+!--    Turbulent impaction
        IF ( tau_plus < 20.0_wp )  THEN
-          v_it = 2.5E-3_wp * C_IT * tau_plus**2.0_wp
+          v_it = 2.5E-3_wp * c_turb_impaction * tau_plus**2
        ELSE
-          v_it = C_IT
-       ENDIF
-       depo = ( v_bd + v_in + v_im + v_it + vc ) * lad     
-       paero(b)%numc = paero(b)%numc - depo * paero(b)%numc * dt_salsa     
-       DO  c = 1, maxspec+1
-          paero(b)%volc(c) = paero(b)%volc(c) - depo * paero(b)%volc(c) *      &
-                             dt_salsa
-       ENDDO
-    ENDIF  
- 
- END SUBROUTINE depo_vege
- 
+          v_it = c_turb_impaction
+       ENDIF
+
+       depo = ( v_bd + v_in + v_im + v_it + vc ) * lad
+
+    ENDIF
+!
+!-- Calculate the change in concentrations
+    paero(ib)%numc = paero(ib)%numc - depo * paero(ib)%numc * dt_salsa
+    DO  ic = 1, maxspec+1
+       paero(ib)%volc(ic) = paero(ib)%volc(ic) - depo * paero(ib)%volc(ic) * dt_salsa
+    ENDDO
+
+ END SUBROUTINE depo_pcm
+
 !------------------------------------------------------------------------------!
 ! Description:
-! ------------  
-!> Calculate deposition on horizontal and vertical surfaces. Implement as 
-!> surface flux.
-!------------------------------------------------------------------------------!
-
- SUBROUTINE depo_topo( i, j, surf, vc, Sc, kvis, mag_u, norm )
- 
+! ------------
+!> Calculate the dry deposition on horizontal and vertical surfaces. Implement
+!> as a surface flux.
+!> @todo aerodynamic resistance ignored for now (not important for 
+!        high-resolution simulations)
+!------------------------------------------------------------------------------!
+ SUBROUTINE depo_surf( i, j, surf, vc, schmidt_num, kvis, mag_u, norm, l )
+
+    USE arrays_3d,                                                             &
+        ONLY: rho_air_zw
+
     USE surface_mod,                                                           &
         ONLY:  surf_type
- 
+
     IMPLICIT NONE
-    
+
+    INTEGER(iwp) ::  ib      !< loop index
+    INTEGER(iwp) ::  ic      !< loop index
+    INTEGER(iwp) ::  icc     !< additional loop index
+    INTEGER(iwp) ::  k       !< loop index
+    INTEGER(iwp) ::  m       !< loop index
+    INTEGER(iwp) ::  surf_e  !< End index of surface elements at (j,i)-gridpoint
+    INTEGER(iwp) ::  surf_s  !< Start index of surface elements at (j,i)-gridpoint
+
     INTEGER(iwp), INTENT(in) ::  i     !< loop index
     INTEGER(iwp), INTENT(in) ::  j     !< loop index
-    REAL(wp), INTENT(in) ::  kvis(:)   !< kinematic viscosity of air (m2/s) 
-    REAL(wp), INTENT(in) ::  mag_u(:)  !< wind velocity (m/s)                                                 
-    REAL(wp), INTENT(in) ::  norm(:)   !< normalisation (usually air density)
-    REAL(wp), INTENT(in) ::  Sc(:,:)  !< particle Schmidt number 
-    REAL(wp), INTENT(in) ::  vc(:,:)  !< terminal velocity (m/s)   
-    TYPE(surf_type), INTENT(inout) :: surf  !< respective surface type 
-    INTEGER(iwp) ::  b      !< loop index
-    INTEGER(iwp) ::  c      !< loop index
-    INTEGER(iwp) ::  k      !< loop index
-    INTEGER(iwp) ::  m      !< loop index
-    INTEGER(iwp) ::  surf_e !< End index of surface elements at (j,i)-gridpoint
-    INTEGER(iwp) ::  surf_s !< Start index of surface elements at (j,i)-gridpoint
-    REAL(wp) ::  alpha      !< parameter, Table 3 in Zhang et al. (2001) 
-    REAL(wp) ::  C_Br       !< coefficient for Brownian diffusion
-    REAL(wp) ::  C_IM       !< coefficient for inertial impaction
-    REAL(wp) ::  C_IN       !< coefficient for interception
-    REAL(wp) ::  C_IT       !< coefficient for turbulent impaction 
-    REAL(wp) ::  depo       !< deposition efficiency
-    REAL(wp) ::  gamma      !< parameter, Table 3 in Zhang et al. (2001) 
-    REAL(wp) ::  par_A      !< parameter A for the characteristic radius of 
-                            !< collectors, Table 3 in Zhang et al. (2001) 
-    REAL(wp) ::  rt         !< the overall quasi-laminar resistance for 
-                            !< particles
-    REAL(wp) ::  St         !< Stokes number for bluff surface elements  
-    REAL(wp) ::  tau_plus   !< dimensionless particle relaxation time   
-    REAL(wp) ::  v_bd       !< deposition velocity due to Brownian diffusion
-    REAL(wp) ::  v_im       !< deposition velocity due to impaction
-    REAL(wp) ::  v_in       !< deposition velocity due to interception
-    REAL(wp) ::  v_it       !< deposition velocity due to turbulent impaction  
-!
-!-- Initialise 
-    rt       = 0.0_wp
-    St       = 0.0_wp
+
+    INTEGER(iwp), INTENT(in), OPTIONAL ::  l  !< index variable for surface facing
+
+    LOGICAL, INTENT(in) ::  norm      !< to normalise or not
+
+    REAL(wp) ::  alpha             !< parameter, Table 3 in Z01
+    REAL(wp) ::  beta_im           !< parameter for turbulent impaction
+    REAL(wp) ::  c_brownian_diff   !< coefficient for Brownian diffusion
+    REAL(wp) ::  c_impaction       !< coefficient for inertial impaction
+    REAL(wp) ::  c_interception    !< coefficient for interception
+    REAL(wp) ::  c_turb_impaction  !< coefficient for turbulent impaction
+    REAL(wp) ::  depo              !< deposition efficiency
+    REAL(wp) ::  gamma             !< parameter, Table 3 in Z01
+    REAL(wp) ::  norm_fac          !< normalisation factor (usually air density)
+    REAL(wp) ::  par_a             !< parameter A for the characteristic radius of collectors,
+                                   !< Table 3 in Z01
+    REAL(wp) ::  par_l             !< obstacle characteristic dimension in P10
+    REAL(wp) ::  rs                !< the overall quasi-laminar resistance for particles
+    REAL(wp) ::  stokes_num        !< Stokes number for bluff surface elements
+    REAL(wp) ::  tau_plus          !< dimensionless particle relaxation time
+    REAL(wp) ::  v_bd              !< deposition velocity due to Brownian diffusion
+    REAL(wp) ::  v_im              !< deposition velocity due to impaction
+    REAL(wp) ::  v_in              !< deposition velocity due to interception
+    REAL(wp) ::  v_it              !< deposition velocity due to turbulent impaction
+
+    REAL(wp), DIMENSION(:), INTENT(in) ::  kvis   !< kinematic viscosity of air (m2/s)
+    REAL(wp), DIMENSION(:), INTENT(in) ::  mag_u  !< wind velocity (m/s)
+
+    REAL(wp), DIMENSION(:,:), INTENT(in) ::  schmidt_num   !< particle Schmidt number
+    REAL(wp), DIMENSION(:,:), INTENT(in) ::  vc            !< terminal velocity (m/s)
+
+    TYPE(surf_type), INTENT(inout) :: surf  !< respective surface type
+!
+!-- Initialise
+    rs       = 0.0_wp
+    surf_s   = surf%start_index(j,i)
+    surf_e   = surf%end_index(j,i)
     tau_plus = 0.0_wp
-    v_bd     = 0.0_wp     
-    v_im     = 0.0_wp        
-    v_in     = 0.0_wp        
-    v_it     = 0.0_wp                                 
-    surf_s   = surf%start_index(j,i)
-    surf_e   = surf%end_index(j,i) 
-    
-    DO  m = surf_s, surf_e 
-       k = surf%k(m)        
-       DO  b = 1, nbins
-          IF ( aerosol_number(b)%conc(k,j,i) <= nclim  .OR.                    &
-               Sc(k+1,b) < 1.0_wp )  CYCLE   
-                    
-          IF ( depo_topo_type == 'zhang2001' )  THEN
-!       
-!--          Parameters for the land use category 'urban' in Table 3
-             alpha = 1.5_wp
-             gamma = 0.56_wp 
-             par_A = 10.0E-3_wp
-!       
+    v_bd     = 0.0_wp
+    v_im     = 0.0_wp
+    v_in     = 0.0_wp
+    v_it     = 0.0_wp
+!
+!-- Model parameters for the land use category. If LSM is applied, import
+!-- characteristics. Otherwise, apply surface type "urban".
+    alpha   = alpha_z01(luc_urban)
+    gamma   = gamma_z01(luc_urban)
+    par_a   = A_z01(luc_urban, season) * 1.0E-3_wp
+
+    par_l            = l_p10(luc_urban) * 0.01_wp
+    c_brownian_diff  = c_b_p10(luc_urban)
+    c_interception   = c_in_p10(luc_urban)
+    c_impaction      = c_im_p10(luc_urban)
+    beta_im          = beta_im_p10(luc_urban)
+    c_turb_impaction = c_it_p10(luc_urban)
+
+    DO  m = surf_s, surf_e
+       k = surf%k(m)
+
+       IF ( norm )  THEN
+          norm_fac = rho_air_zw(k)
+          IF ( land_surface )  THEN
+             alpha            = alpha_z01( lsm_to_depo_h%match(m) )
+             beta_im          = beta_im_p10( lsm_to_depo_h%match(m) )
+             c_brownian_diff  = c_b_p10( lsm_to_depo_h%match(m) )
+             c_impaction      = c_im_p10( lsm_to_depo_h%match(m) )
+             c_interception   = c_in_p10( lsm_to_depo_h%match(m) )
+             c_turb_impaction = c_it_p10( lsm_to_depo_h%match(m) )
+             gamma            = gamma_z01( lsm_to_depo_h%match(m) )
+             par_a            = A_z01( lsm_to_depo_h%match(m), season ) * 1.0E-3_wp
+             par_l            = l_p10( lsm_to_depo_h%match(m) ) * 0.01_wp
+          ENDIF
+       ELSE
+          norm_fac = 0.0_wp
+          IF ( land_surface )  THEN
+             alpha            = alpha_z01( lsm_to_depo_v(l)%match(m) )
+             beta_im          = beta_im_p10( lsm_to_depo_v(l)%match(m) )
+             c_brownian_diff  = c_b_p10( lsm_to_depo_v(l)%match(m) )
+             c_impaction      = c_im_p10( lsm_to_depo_v(l)%match(m) )
+             c_interception   = c_in_p10( lsm_to_depo_v(l)%match(m) )
+             c_turb_impaction = c_it_p10( lsm_to_depo_v(l)%match(m) )
+             gamma            = gamma_z01( lsm_to_depo_v(l)%match(m) )
+             par_a            = A_z01( lsm_to_depo_v(l)%match(m), season ) * 1.0E-3_wp
+             par_l            = l_p10( lsm_to_depo_v(l)%match(m) ) * 0.01_wp
+          ENDIF
+       ENDIF
+
+       DO  ib = 1, nbins_aerosol
+          IF ( aerosol_number(ib)%conc(k,j,i) <= nclim  .OR.  schmidt_num(k+1,ib) < 1.0_wp )  CYCLE
+
+          IF ( depo_surf_par == 'zhang2001' )  THEN
+!
 !--          Stokes number for smooth surfaces or surfaces with bluff roughness
-!--          elements (Seinfeld and Pandis, 2nd edition (2006): Eq. 19.23)       
-             St = MAX( 0.01_wp, vc(k+1,b) * surf%us(m) ** 2.0_wp /             &
-                       ( g * kvis(k+1)  ) ) 
-!          
-!--          The overall quasi-laminar resistance for particles (Eq. 5)        
-             rt = MAX( EPSILON( 1.0_wp ), ( 3.0_wp * surf%us(m) * (            &
-                       Sc(k+1,b)**( -gamma ) + ( St / ( alpha + St ) )**2.0_wp &
-                        + 0.5_wp * ( Ra_dry(k,j,i,b) / par_A )**2.0_wp ) *     &
-                       EXP( -St**0.5_wp ) ) ) 
-             depo = vc(k+1,b) + rt
-             
-          ELSEIF ( depo_topo_type == 'petroff2010' )  THEN 
-!
-!--          vd = v_BD + v_IN + v_IM + v_IT + vc 
-!--          Deposition efficiencies from Table 1. Constants from Table 2.
-             C_Br  = 1.262_wp
-             C_IM  = 0.130_wp
-             C_IN  = 0.216_wp
-             C_IT  = 0.056_wp
-             par_A = 0.03_wp   ! Here: leaf width (m)  
-!       
+!--          elements (Seinfeld and Pandis, 2nd edition (2006): Eq. 19.23)
+             stokes_num = MAX( 0.01_wp, vc(k+1,ib) * surf%us(m)**2 / ( g * kvis(k+1)  ) )
+!
+!--          The overall quasi-laminar resistance for particles (Eq. 5)
+             rs = MAX( EPSILON( 1.0_wp ), ( 3.0_wp * surf%us(m) * ( schmidt_num(k+1,ib)**( -gamma )&
+                       + ( stokes_num / ( alpha + stokes_num ) )**2 + 0.5_wp * ( ra_dry(k,j,i,ib) /&
+                       par_a )**2 ) * EXP( -stokes_num**0.5_wp ) ) )
+             depo = vc(k+1,ib) + rs
+
+          ELSEIF ( depo_surf_par == 'petroff2010' )  THEN 
+!
+!--          vd = v_BD + v_IN + v_IM + v_IT + vc
+!
 !--          Stokes number for smooth surfaces or surfaces with bluff roughness
-!--          elements (Seinfeld and Pandis, 2nd edition (2006): Eq. 19.23)       
-             St = MAX( 0.01_wp, vc(k+1,b) * surf%us(m) ** 2.0_wp /             &
-                       ( g *  kvis(k+1) ) )              
+!--          elements (Seinfeld and Pandis, 2nd edition (2006): Eq. 19.23)
+             stokes_num = MAX( 0.01_wp, vc(k+1,ib) * surf%us(m)**2 / ( g *  kvis(k+1) ) )
 !
 !--          Non-dimensional relexation time of the particle on top of canopy
-             tau_plus = vc(k+1,b) * surf%us(m)**2.0_wp / ( kvis(k+1) * g ) 
+             tau_plus = vc(k+1,ib) * surf%us(m)**2 / ( kvis(k+1) * g )
 !
 !--          Brownian diffusion
-             v_bd = mag_u(k+1) * C_Br * Sc(k+1,b)**( -2.0_wp / 3.0_wp ) *      &
-                    ( mag_u(k+1) * par_A / kvis(k+1) )**( -0.5_wp )
+             v_bd = mag_u(k+1) * c_brownian_diff * schmidt_num(k+1,ib)**( -0.666666_wp ) *         &
+                    ( mag_u(k+1) * par_l / kvis(k+1) )**( -0.5_wp )
 !
 !--          Interception
-             v_in = mag_u(k+1) * C_IN * Ra_dry(k,j,i,b)/ par_A * ( 2.0_wp +    &
-                    LOG( 2.0_wp * par_A / Ra_dry(k,j,i,b) ) )                     
+             v_in = mag_u(k+1) * c_interception * ra_dry(k,j,i,ib)/ par_l *                        &
+                    ( 2.0_wp + LOG( 2.0_wp * par_l / ra_dry(k,j,i,ib) ) )
 !
 !--          Impaction: Petroff (2009) Eq. 18
-             v_im = mag_u(k+1) * C_IM * ( St / ( St + 0.47_wp ) )**2.0_wp
-             
+             v_im = mag_u(k+1) * c_impaction * ( stokes_num / ( stokes_num + beta_im ) )**2
+
              IF ( tau_plus < 20.0_wp )  THEN
-                v_it = 2.5E-3_wp * C_IT * tau_plus**2.0_wp
+                v_it = 2.5E-3_wp * c_turb_impaction * tau_plus**2
              ELSE
-                v_it = C_IT
+                v_it = c_turb_impaction
              ENDIF
-             depo =  v_bd + v_in + v_im + v_it + vc(k+1,b)        
-          
+             depo =  v_bd + v_in + v_im + v_it + vc(k+1,ib)
+
           ENDIF
-          IF ( lod_aero == 3  .OR.  salsa_source_mode ==  'no_source' )  THEN
-             surf%answs(m,b) = -depo * norm(k) * aerosol_number(b)%conc(k,j,i) 
-             DO  c = 1, ncc_tot    
-                surf%amsws(m,(c-1)*nbins+b) = -depo *  norm(k) *               &
-                                         aerosol_mass((c-1)*nbins+b)%conc(k,j,i)
-             ENDDO    ! c
+!
+!--       Calculate changes in surface fluxes due to dry deposition
+          IF ( aero_emission_att%lod == 2  .OR.  salsa_emission_mode ==  'no_emission' )  THEN
+             surf%answs(m,ib) = -depo * norm_fac * aerosol_number(ib)%conc(k,j,i)
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                surf%amsws(m,icc) = -depo *  norm_fac * aerosol_mass(icc)%conc(k,j,i)
+             ENDDO    ! ic
           ELSE
-             surf%answs(m,b) = SUM( aerosol_number(b)%source(:,j,i) ) -        &
-                               MAX( 0.0_wp, depo * norm(k) *                   &
-                               aerosol_number(b)%conc(k,j,i) )
-             DO  c = 1, ncc_tot    
-                surf%amsws(m,(c-1)*nbins+b) = SUM(                             &
-                               aerosol_mass((c-1)*nbins+b)%source(:,j,i) ) -   &
-                               MAX(  0.0_wp, depo *  norm(k) *                 &
-                               aerosol_mass((c-1)*nbins+b)%conc(k,j,i) )
-             ENDDO 
+             surf%answs(m,ib) = aerosol_number(ib)%source(j,i) -                                   &
+                                MAX( 0.0_wp, depo * norm_fac * aerosol_number(ib)%conc(k,j,i) )
+             DO  ic = 1, ncomponents_mass
+                icc = ( ic - 1 ) * nbins_aerosol + ib
+                surf%amsws(m,icc) = aerosol_mass(icc)%source(j,i) -                                &
+                                    MAX( 0.0_wp, depo *  norm_fac * aerosol_mass(icc)%conc(k,j,i) )
+             ENDDO  ! ic
           ENDIF
-       ENDDO    ! b
-    ENDDO    ! m     
-     
- END SUBROUTINE depo_topo
- 
+       ENDDO    ! ib
+    ENDDO    ! m
+
+ END SUBROUTINE depo_surf
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -3443,7 +3658,7 @@
 !------------------------------------------------------------------------------!
  REAL(wp) FUNCTION terminal_vel( radius, rhop, rhoa, visc, beta )
- 
+
     IMPLICIT NONE
-   
+
     REAL(wp), INTENT(in) ::  beta    !< Cunningham correction factor
     REAL(wp), INTENT(in) ::  radius  !< particle radius (m)
@@ -3451,12 +3666,11 @@
     REAL(wp), INTENT(in) ::  rhoa    !< air density (kg/m3)
     REAL(wp), INTENT(in) ::  visc    !< molecular viscosity of air (kg/(m*s))
-    
+
 !
 !-- Stokes law with Cunningham slip correction factor
-    terminal_vel = ( 4.0_wp * radius**2.0_wp ) * ( rhop - rhoa ) * g * beta /  &
-                   ( 18.0_wp * visc ) ! (m/s)
-        
+    terminal_vel = 4.0_wp * radius**2 * ( rhop - rhoa ) * g * beta / ( 18.0_wp * visc ) ! (m/s)
+
  END FUNCTION terminal_vel
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -3498,31 +3712,31 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE coagulation( paero, ptstep, ptemp, ppres )
-               
+
     IMPLICIT NONE
-    
-!-- Input and output variables
-    TYPE(t_section), INTENT(inout) ::  paero(fn2b) !< Aerosol properties
-    REAL(wp), INTENT(in) ::  ppres  !< ambient pressure (Pa)
-    REAL(wp), INTENT(in) ::  ptemp  !< ambient temperature (K) 
-    REAL(wp), INTENT(in) ::  ptstep !< time step (s)
-!-- Local variables
+
     INTEGER(iwp) ::  index_2a !< corresponding bin in subrange 2a
     INTEGER(iwp) ::  index_2b !< corresponding bin in subrange 2b
-    INTEGER(iwp) ::  b !< loop index
-    INTEGER(iwp) ::  ll !< loop index
-    INTEGER(iwp) ::  mm !< loop index
-    INTEGER(iwp) ::  nn !< loop index
-    REAL(wp) ::  pressi !< pressure
-    REAL(wp) ::  temppi !< temperature
-    REAL(wp) ::  zcc(fn2b,fn2b)   !< updated coagulation coefficients (m3/s)  
-    REAL(wp) ::  zdpart_mm        !< diameter of particle (m)
-    REAL(wp) ::  zdpart_nn        !< diameter of particle (m)    
-    REAL(wp) ::  zminusterm       !< coagulation loss in a bin (1/s)
-    REAL(wp) ::  zplusterm(8)     !< coagulation gain in a bin (fxm/s)
-                                  !< (for each chemical compound)
-    REAL(wp) ::  zmpart(fn2b)     !< approximate mass of particles (kg)
-    
-    zcc       = 0.0_wp
-    zmpart    = 0.0_wp
+    INTEGER(iwp) ::  ib       !< loop index
+    INTEGER(iwp) ::  ll       !< loop index
+    INTEGER(iwp) ::  mm       !< loop index
+    INTEGER(iwp) ::  nn       !< loop index
+
+    REAL(wp) ::  pressi          !< pressure
+    REAL(wp) ::  temppi          !< temperature
+    REAL(wp) ::  zdpart_mm       !< diameter of particle (m)
+    REAL(wp) ::  zdpart_nn       !< diameter of particle (m)
+    REAL(wp) ::  zminusterm      !< coagulation loss in a bin (1/s)
+
+    REAL(wp), INTENT(in) ::  ppres  !< ambient pressure (Pa)
+    REAL(wp), INTENT(in) ::  ptemp  !< ambient temperature (K)
+    REAL(wp), INTENT(in) ::  ptstep !< time step (s)
+
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zmpart     !< approximate mass of particles (kg)
+    REAL(wp), DIMENSION(maxspec+1)     ::  zplusterm  !< coagulation gain in a bin (for each
+                                                      !< chemical compound)
+    REAL(wp), DIMENSION(nbins_aerosol,nbins_aerosol) ::  zcc  !< updated coagulation coefficients (m3/s)
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  paero  !< Aerosol properties
+
     zdpart_mm = 0.0_wp
     zdpart_nn = 0.0_wp
@@ -3533,8 +3747,8 @@
 
 !-- 2) Updating coagulation coefficients 
-!    
+!
 !-- Aerosol mass (kg). Density of 1500 kg/m3 assumed
-    zmpart(1:fn2b) = api6 * ( MIN( paero(1:fn2b)%dwet, 30.0E-6_wp )**3.0_wp  ) &
-                     * 1500.0_wp 
+    zmpart(1:end_subrange_2b) = api6 * ( MIN( paero(1:end_subrange_2b)%dwet, 30.0E-6_wp )**3 )     &
+                                * 1500.0_wp
     temppi = ptemp
     pressi = ppres
